import java.util.ArrayList;

public class TextLogik {
    private final Text text;
    private final TextOutput textOutput;

    /**
     * Initiates a new instance of the class TextLogik.
     * Contains command instructions for the class Text.
     * Defined the different cases and appointed to specific commands.
     */
    public TextLogik() {
        text = new Text();
        textOutput = new TextOutput();
        String[] command;

        do {
            command = TextInput.checkForInput();

            switch (command[0]) {
                case "ADD":

                    if (command.length == 1) {
                        text.add(TextInput.getTextInput());
                    } else if (isNumeric(command[1])) {
                        int line = Integer.parseInt(command[1]);

                        text.add(line, TextInput.getTextInput());
                    } else {
                        textOutput.errorInvalidCommand();
                    }

                    break;
                case "DEL":
                    if (command.length == 1) {
                        text.del();
                    } else if (isNumeric(command[1])) {
                        int line = Integer.parseInt(command[1]);
                        text.del(line);
                    } else {
                        textOutput.errorInvalidCommand();
                    }
                    break;
                case "Dummy":
                    text.dummy();
                    break;
                case "EXIT":
                    break;
                case "FORMAT":
                    if (command.length > 1 && "RAW".equals(command[1])) {
                        textOutput.formatRaw();
                    } else if (command.length > 2 && "FIX".equals(command[1]) && isNumeric(command[2])) {
                        textOutput.formatFix(Integer.parseInt(command[2]));
                    } else {
                        textOutput.errorInvalidCommand();
                    }

                    break;
                case "INDEX":
                    ArrayList<String> Index = text.index();
                    break;
                case "PRINT":

                    textOutput.print(text.getText());

                    break;
                case "REPLACE":
                    if (command.length == 1){
                        text.replace(TextInput.getTextInput(), TextInput.getTextInput());
                    }else if(isNumeric(command[1])) {
                        int line = Integer.parseInt(command[1]);

                        text.replace(line, TextInput.getTextInput(), TextInput.getTextInput());
                    }else {
                        textOutput.errorInvalidCommand();
                    }

                    break;
                default:
                    System.out.println("Command not found. Try again");
                    break;
            }

        } while (!"EXIT".equals(command[0]));
    }

    /**
     * Method to check if a command is numeric.
     *
     * @param str command that should be a number.
     * @return true if the given str matches.
     */
    private boolean isNumeric(String str) {
        return str.matches("\\d+");
    }

}
